/* gauss.c
 * returns pdf and cdf of the Normal (Gauss-Laplace) distribution
 * Thu Dec 30 11:35:02 GMT 2004 Peter A. Cejchan <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>, GPL license
 */

#include <u.h>
#include <libc.h>

#define STEPS 100000
#define HALF 6.0

double
gaussian_pdf (const double x, const double mu, const double sigma);

double
gaussian_cdf (const double x, const double mu, const double sigma);

double
gaussian_pdf (const double x, const double mu, const double sigma)
{
  double u = (x-mu) / fabs (sigma);
  double p = (1 / (sqrt (2 * PI) * fabs (sigma))) * exp (-u * u / 2);
  return p;
}

double
gaussian_cdf (const double x, const double mu, const double sigma)
{
// rough and ugly, brute force, but works!
	int i;
	double step, sum, xcurr;
	if(x< -HALF) return 0.0;
	if(x> +HALF) return 1.0;
	xcurr=-HALF*sigma;
	step=(HALF*sigma+x)/STEPS;
	sum=0;
	for(i=0; i<STEPS; i++){
		sum += gaussian_pdf (xcurr, mu, sigma)*step;
		xcurr+=step;
	}
	return sum;
}

void
main(int argc, char *argv[])
{
double mu, sigma;
int i;
mu= atof(argv[1]);
sigma= atof(argv[2]);

	for(i=0; i<10; i++){
		print("%f\n", gaussian_cdf ((double)i, mu, sigma));
	}
}